//	author:	Barnabas Aszodi (BME-IIT)

#include "Ogre.h"
#include "OgreEffectWrapper.h"
#include "ManagedOgreRenderTexturePass.h"
#include "CAURenderPhotonHitMapPass.h"

CAURenderPhotonHitMapPass::CAURenderPhotonHitMapPass( 
	Root* mRoot):ManagedOgreRenderTexturePass(mRoot,"NO_RENDER_TARGET",1,1)
{
	effectWrapper->createMaterial("RenderPhotonHit");
}

void CAURenderPhotonHitMapPass::onRenderStart(NameValuePairList* namedParams){
	effectWrapper->SetTechniqueToUse(0);
	effectWrapper->BeginPass();
	effectWrapper->SetFragmentProgramParameters();
	effectWrapper->SetFloat("g_fPower",g_fPower);
}


void CAURenderPhotonHitMapPass::onRenderEnd(NameValuePairList* namedParams)
{
	effectWrapper->EndPass();
}

float CAURenderPhotonHitMapPass::getPower()
{
	return g_fPower;
}

void CAURenderPhotonHitMapPass::setPower( float f )
{
	g_fPower = f;
}
