#ifndef __X3DEXPORTER_H
#define __X3DEXPORTER_H

#include <string>
using std::string;

#include <iostream>
#include <fstream>

#include "Exporter.h"

class SceneGraphNode;
class Mesh;



class X3dExporter : public Exporter
{
  std::ofstream stream;

public:

  X3dExporter(const string filename);

  ~X3dExporter();


  bool
  ExportRays(const vector<Ray> &rays, const float length=1000);

  bool
  ExportKdTree(const KdTree &tree);
  
  bool
  ExportScene(SceneGraphNode *root) 
  {
    ExportSceneNode(root);
    return true;
  }
  
  bool
  ExportBox(const AxisAlignedBox3 &box);

  virtual void
  ExportMeshInstance(MeshInstance *mi);

  void
  ExportMesh(Mesh *mesh);

protected:
  void
  ExportSceneNode(SceneGraphNode *node);
  

  
};
 


#endif
